/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;

public class HotListPanel extends JPanel implements ActionListener, MouseListener
{
  JList userList;
  JTable userInfo;
  HotListDataModel hldm;
  JButton adduser, removeuser, download;
  String EOL = "\r\n";
  BufferedReader is;
  PrintStream os;
  UserListModel ulm;
  
  public HotListPanel()
  {
    super();

    this.setLayout( new BorderLayout() );

    ulm = new UserListModel();
    userList = new JList( ulm );
    userList.setSelectionMode( ListSelectionModel.MULTIPLE_INTERVAL_SELECTION );
    userList.setPreferredSize( new Dimension( 250, 500 ));
    userList.addMouseListener( this );
    
    hldm = new HotListDataModel();
    userInfo = new JTable( hldm );
    userInfo.setPreferredSize( new Dimension( 250, 500 ));
    JSplitPane splitPane = new JSplitPane( JSplitPane.HORIZONTAL_SPLIT, true,
                                           userList, userInfo );
    add( splitPane, "Center" );

    
    JPanel buttons = new JPanel();
    adduser = new JButton( "Add User" );
    adduser.addActionListener( this );
    buttons.add( adduser );
    removeuser = new JButton( "Remove User" );
    removeuser.addActionListener( this );
    buttons.add( removeuser );
    download = new JButton( "Download File" );
    download.addActionListener( this );
    buttons.add( download );
    add( buttons, "South" );
  }
  
  public void mouseClicked(MouseEvent me) 
  {
    getResults((String)userList.getSelectedValue());
  }
  
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
  
  private String getSeparator( String test )
  {
    if( test.indexOf("/") > 0 )
      return "/";
    else
      return "\\";
  }
  
  public void actionPerformed( ActionEvent e )
  {
    if( e.getSource() == download )
      {
        int row = userInfo.getSelectedRow();
	String path = hldm.getPathAt(row);
	String file = hldm.getFilenameAt(row);
	String searchfilename = null;
	if( path.endsWith("/") || path.endsWith("\\"))
	  searchfilename = path + file;
	else 
	  searchfilename = path + getSeparator(path) + file;
	
	Download download = new Download((String)userList.getSelectedValue(), searchfilename, 
					 hldm.getSizeAt(row), hldm.getIpAt(row), hldm.getPortAt(row) );
      }
  }

  public void addUser( String username )
  {
    ulm.addElement( username );
  }

  public Vector getUsers()
  {
    return ulm.getElements();
  }
  
  public void getResults( String username )
  {
    is = (BufferedReader)ConnectionPool.get( "READER" );
    os = (PrintStream)ConnectionPool.get( "WRITER" );
    
    try{
      System.out.println("***** SEARCH *****" );
      
      StringBuffer search = new StringBuffer();
      
      search.append( "STP/1.0 SEARCH" + EOL );
      search.append("Search-ID: 1" + EOL);
      search.append("Username: " + username + EOL );
      search.append("Num-Results: 300" + EOL);
      search.append( "Duration: >0" + EOL );
      search.append(EOL);
      
      os.print( search.toString() );
      System.out.println(search);
      
      String result = null, searchid = null, type, offset, num;
      int numresults;
      
      boolean recieved = false;
      while( !recieved )
        {
          result = is.readLine();
          System.out.println("\n\nresult = " + result );
          
//        if( !(result.trim()).startsWith("STP/1.0 30" ))
          if( result.equals("STP/1.0 STAT") )
            {
              // we are recieving a STAT message...
              recieved = false;
              try{
                ParseStatInfo psi = new ParseStatInfo();
                psi.parse( is );
              }catch(IOException ioe){
                System.out.println("Search: " + ioe );
              }
            }
          else if( result.equals("STP/1.0 300 OK" ))
            {
              System.out.println("********************");
              System.out.println("recieved set to true");
              System.out.println("result = " + result );
              System.out.println("********************");
              recieved = true;
            }
          else
            return;
        }

      System.out.println("*********************************");
      System.out.println("** lets start parsing the results");
      System.out.println("*********************************");
      
//        searchid = is.readLine();
//        type = is.readLine();
//        type = type.substring( type.indexOf(":"));
//        offset = is.readLine();
//        offset = offset.substring( offset.indexOf(":")+1);
//        num = is.readLine();
//        num = num.substring(num.indexOf(":")+1);
//        numresults = Integer.parseInt( num.trim() );
      
      StringBuffer buffer = new StringBuffer();
      String line = null;
      while( (line = is.readLine()).length() > 0 )
        {
//  	  System.out.println("line = " + line );
          buffer.append( line + "\n" );
        }
      
      ResultTokenizer stz = new ResultTokenizer( buffer.toString(), "Filename", true );
      try{
        while( stz.hasMoreTokens() )
          {
            String searchresult = stz.nextToken();
            
            ResultTokenizer tokenizer = new ResultTokenizer( searchresult.toString(), "\n", false );
            SearchResult sr =  new SearchResult();
            while( tokenizer.hasMoreTokens() )
              {
                String token = null;
                
                try{
                  token = (tokenizer.nextToken()).trim();
                }catch(StringIndexOutOfBoundsException ex){
                  break;
                }
                
                int colon = token.indexOf(":");
                String first = (token.substring(0, colon )).trim();
                String second = (token.substring( colon+1 )).trim();
                
                if( first.equals( "Filename" ))
                  {
                    String sep;
                    if( second.indexOf( "\\" ) > 0)
                      sep = "\\";
                    else 
                      sep = "/";
                    
                    String filename = (second.trim()).substring( second.lastIndexOf(sep)+1);
                    sr.add( first, filename );
                    String path = (second.trim()).substring( 0, second.lastIndexOf(sep));
                    sr.add( "Path", path );
                  }
                else
                  sr.add( first, second );
              }
            hldm.addRow( sr );
          }
      }catch(StringIndexOutOfBoundsException ex){
        System.out.println("Search: " + ex.getMessage() );
      }
      
//        String nothing = is.readLine();
//        if( nothing.length() > 0 )
//      System.out.println("Search: nothing = " + nothing);
      
    }catch(Exception e){
      System.out.println(e);
    }
  }
}
