/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import java.net.*;
import java.io.*;
import java.security.MessageDigest;

public class Login 
{
  private String EOL = "\r\n";
  public BufferedReader is;
  public PrintStream os;
  private String servername = "stp.scour.net";
  private int portnumber = 80;
  private Socket socket;
  
  public Login()
  {
  }
  
  public boolean canLogin( String username, String password )
  {
    try{
      socket = new Socket( servername, portnumber );
      is = new BufferedReader( new InputStreamReader( socket.getInputStream()));
      os = new PrintStream( socket.getOutputStream() );
      
      ConnectionPool.setup();
      ConnectionPool.add( "READER", is );
      ConnectionPool.add( "WRITER", os );      
      ConnectionPool.add( "USERNAME", username );
      
      StringBuffer login = new StringBuffer();
      
      login.append( "STP/1.0 LOGIN" + EOL );
      login.append( "User-Agent: JavaScour v0.1a" + EOL );
      login.append( "Username: " + username + "" + EOL );
      
      MessageDigest md5 = MessageDigest.getInstance( "md5" );
      String pw = new String( password.trim() );
      md5.update( pw.getBytes( "ISO8859-1") );
      byte[] array = md5.digest();
      StringBuffer sb = new StringBuffer();
      for( int x=0; x<16; x++ )
        {
          if( ((int)array[x] & 0xff) < 0x10 )
            sb.append( "0" );
          sb.append( Long.toString( (int)array[x] & 0xff, 16 ));
        }
      
      login.append( "Password: " + sb.toString() + "" + EOL );
      login.append( "IP: " + socket.getLocalAddress().getHostAddress() + "" + EOL );
      login.append( "Port: " + portnumber + EOL);
      login.append( EOL );
      
      os.print( login.toString() );
//        System.out.println("login:\n" + login);
      
      String line = is.readLine();
      if( !(line.indexOf( "100" ) > 0))
        {
          System.out.println("There was a problem logging into scour");
          System.out.println( line );
          return false;
        }
      String firewall = is.readLine();
      ConnectionPool.add( "FIREWALL", firewall );
      System.out.println("firewall status -- " + firewall );
      
      is.readLine();
    }catch(Exception e){
      System.out.println(e);
      return false;
    }
    return true;
  }
  
}
