/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class NewUserLogin implements ActionListener
{
  JFrame frame;
  JTextField name, email, zip;
  JComboBox sex, age, speed;
  JCheckBox subscribe;
  JRadioButton lan, modem, html, text;
  JButton next, cancel, back, finish;
  CardLayout cardlayout;
  JTextField username;
  JPasswordField password1, password2;
  String lanspeed[] = { "Cable Modem", "DSL", "T1", "T3", "T3 or Greater" };
  String modemspeed[] = { "14.4 Kbps", "28.8 Kbps", "33.6 Kbps", "56 Kbps", 
                          "64K ISDN", "128K ISDN" };
  String panels[] = { "first", "second" };
  
  public NewUserLogin()
  {
    frame = new JFrame( "New User Login" );
    
    cardlayout = new CardLayout();
    frame.getContentPane().setLayout( cardlayout ); 
    
    JPanel first = createfirstpanel();
    JPanel second = createsecondpanel();
        
    frame.getContentPane().add( first, panels[0] );
    frame.getContentPane().add( second, panels[1] );

    frame.pack();
    frame.setVisible( true );
  }

  public JPanel createsecondpanel()
  {
    JPanel second = new JPanel();
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    second.setLayout( gbl );
    c.insets = new Insets( 5, 7, 5, 7 );
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    second.add( new JLabel( "Enter and username and password that scour can" ), c);
    c.gridwidth = GridBagConstraints.REMAINDER;
    second.add( new JLabel( "use to identify your member registration and" ), c);
    c.gridwidth = GridBagConstraints.REMAINDER;
    second.add( new JLabel( "protect access to your account" ), c);
    
    c.gridwidth = 1;
    second.add( new JLabel( "Username: " ));
    username = new JTextField( 30 );
    c.gridwidth = GridBagConstraints.REMAINDER;
    second.add( username, c );

    c.gridwidth = 1;
    second.add( new JLabel( "Password: " ));
    password1 = new JPasswordField( 30 );
    c.gridwidth = GridBagConstraints.REMAINDER;
    second.add( password1, c );
    
    c.gridwidth = 1;
    second.add( new JLabel( "Confirm Username: " ));
    password2 = new JPasswordField( 30 );
    c.gridwidth = GridBagConstraints.REMAINDER;
    second.add( password2, c );
    
    JPanel buttons = new JPanel();
    back = new JButton( "Back" );
    back.addActionListener( this );
    buttons.add( back );
    finish = new JButton( "Finish" );
    finish.addActionListener( this );
    buttons.add( finish );
    c.gridwidth = GridBagConstraints.REMAINDER;
    second.add( buttons, c );

    return second;
  }

  public JPanel createfirstpanel()
  {
    JPanel top = new JPanel();
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    top.setLayout( gbl );
    c.insets = new Insets( 5, 7, 5, 7 );
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;

    c.gridwidth = 1;
    top.add( new JLabel( "Name: " ));
    name = new JTextField( 30 );
    c.gridwidth = GridBagConstraints.REMAINDER;
    top.add( name, c );

    c.gridwidth = 1;
    top.add( new JLabel( "Email: " ));
    email = new JTextField( 20 );
    top.add( email, c );
    top.add( new JLabel( "Zip: " ));
    c.gridwidth = GridBagConstraints.REMAINDER;
    zip = new JTextField( 8 );
    top.add( zip, c );

    c.gridwidth = 1;
    top.add( new JLabel( "Sex: " ));
    String[] sexchoice = { "M", "F" };
    sex = new JComboBox( sexchoice );
    top.add( sex );
    top.add( new JLabel( "Age: " ));
    String[] agechoice = { "<16", "16 - 24", "24 - 32", "32 - 45", "> 45" };
    age = new JComboBox( agechoice );
    c.gridwidth = GridBagConstraints.REMAINDER;
    top.add( age, c );

    c.gridwidth = 1;
    top.add( new JLabel( "Connection via: " ));
    ButtonGroup bg = new ButtonGroup();
    lan = new JRadioButton( "LAN" );
    lan.addActionListener( this );
    modem = new JRadioButton( "Modem" );
    modem.addActionListener( this );
    modem.setSelected( true );
    bg.add( lan );
    bg.add( modem );
    top.add( lan );
    c.gridwidth = GridBagConstraints.REMAINDER;
    top.add( modem, c );

    c.gridwidth = 1;
    top.add( new JLabel( "Speed: " ));
    speed = new JComboBox( modemspeed );
    c.gridwidth = GridBagConstraints.REMAINDER;
    top.add( speed, c );
        
    c.gridwidth = 1;
    subscribe = new JCheckBox();
    subscribe.addActionListener( this );
    subscribe.setSelected( true );
    top.add( subscribe );
    top.add( new JLabel( "Subscribe to our newsletter: " ));
    ButtonGroup bg2 = new ButtonGroup();
    html = new JRadioButton( "HTML" );
    html.setSelected( true );
    text = new JRadioButton( "Text" );
    bg2.add( html );
    bg2.add( text );
    top.add( html );
    c.gridwidth = GridBagConstraints.REMAINDER;
    top.add( text, c );
      
    JPanel buttons = new JPanel();
    next = new JButton( "Next" );
    next.addActionListener( this );
    buttons.add( next );
    cancel = new JButton( "Cancel" );
    cancel.addActionListener( this );
    buttons.add( cancel );
 
    c.gridwidth = GridBagConstraints.REMAINDER;
    top.add( buttons, c );
    
    return top;
  }

  public void actionPerformed( ActionEvent e )
  {
    System.out.println( e.getActionCommand() );
    if( e.getSource() == lan )
      {
        speed.removeAllItems();
        for( int i=0; i< lanspeed.length; i++ )
          speed.addItem( lanspeed[i] );
      }
    else if( e.getSource() == modem )
      {
        speed.removeAllItems();
        for( int i=0; i< modemspeed.length; i++ )
          speed.addItem( modemspeed[i] );
      }
    else if( e.getSource() == next )
      {
        if( (name.getText().length() > 0) && (email.getText().length() > 0) && (zip.getText().length() > 0 ))
          cardlayout.show( frame.getContentPane(), panels[1] );
        else
          {
            JOptionPane.showMessageDialog( frame, "You must fill in all required fields", "Error", 
                                           JOptionPane.ERROR_MESSAGE );
            return;
          }
      }
    else if( e.getSource() == back )
      {
        cardlayout.show( frame.getContentPane(), panels[0] );
      }
    else if( e.getSource() == cancel )
      {
        int answer = JOptionPane.showConfirmDialog( frame, "Are you sure you want to cancel?\n" + 
                                                    "This will close JavaScour", "Confirm", 
                                                    JOptionPane.YES_NO_OPTION );
        if( answer == JOptionPane.YES_OPTION )
          {
            System.exit( 0 );
          }
        else 
          return;
      }
    else if( e.getSource() == subscribe )
      {
        if( text.isEnabled() )
          {
            text.setEnabled( false );
            html.setEnabled( false );
          }
        else 
          {
            text.setEnabled( true );
            html.setEnabled( true ); 
          }
      }
    else if( e.getSource() == finish )
      {
        String pass1 = new String( password1.getPassword() );
        String pass2 = new String( password2.getPassword() );
        if( !pass1.equals( pass2 ))
          {
            JOptionPane.showMessageDialog( frame, "The passwords did not match", "Error", 
                                           JOptionPane.ERROR_MESSAGE );
            return;
          }
      }
  }

  public boolean createUser()
  {
    return true;
  }
}
