/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.util.Vector;
import java.util.Enumeration;


public class TransferPanelDataModel extends AbstractTableModel
{
  String[] columns = { "Filename", "Size", "Status", "Progress", "Transferred", 
                       "Transfer Rate", "User", "Connection", "Time Left" };
  boolean[] columnsOnOff = new boolean[columns.length];
  Vector filename = new Vector();
  Vector size = new Vector();
  Vector status = new Vector();
  Vector progress = new Vector();
  Vector transferred = new Vector();
  Vector transferrate = new Vector();
  Vector user = new Vector();
  Vector connection = new Vector();
  Vector timeleft = new Vector();
  Vector entry = new Vector( columns.length );
  
  public TransferPanelDataModel()
  {
    super();
    for(int i=0; i<columns.length; i++)
      columnsOnOff[i]  = true ;
  
    entry.add( filename );
    entry.add( size );
    entry.add( status );
    entry.add( progress );
    entry.add( transferred );
    entry.add( transferrate );
    entry.add( user );
    entry.add( connection );
    entry.add( timeleft );
  }

  public int getColumnCount() 
  {
    int count = 0 ;
    for( int i=0; i<columns.length; i++ )
      if( columnsOnOff[i] == true )
        count++ ;
    return( count ) ;
  }
  
    public Object getValueAt( int row, int column )
    {
      int count = 0 ;
      int i ;
      for( i=0; i<columns.length; i++ )
        {
          if( columnsOnOff[i] == true )
            count++ ;
          if( count == (column+1) )
            break ;
        }
      return( ((Vector)(entry.elementAt(i))).elementAt(row) ) ;
   }
 
  public void setValueAt( Object value, int row, int column )
  {
    Vector vector = (Vector)entry.get( column );
    try{
      vector.setElementAt( value, row );
    }catch(ArrayIndexOutOfBoundsException aioobe){  
      System.out.println("There was a problem setting the value for the contact list");
    }
    fireTableChanged( new TableModelEvent( this, row ) );
  }
  
  public void remove( String file )
  {
    int index = filename.indexOf( file ); 
    remove( index );
  }
  
  public void remove( int row )
  {
    filename.remove( row );
    size.remove( row );
    status.remove( row );
    progress.remove( row );
    transferred.remove( row );
    transferrate.remove( row );
    user.remove( row );
    connection.remove( row );
    timeleft.remove( row );
    fireTableChanged( new TableModelEvent( this, 0, getRowCount(), 
                                           TableModelEvent.ALL_COLUMNS, row ) );
  }

  public void addRow( String fn, String sz, String st, String pr, String tf, String tr, String ur, 
                      String cn, String tl )
  {
    filename.add( fn );
    size.add( sz );
    status.add( st );
    progress.add( pr );
    transferred.add( tf );
    transferrate.add( tr );
    user.add( ur );
    connection.add( cn );
    timeleft.add( tl );
    fireTableChanged( new TableModelEvent( this, filename.size(), filename.size(), 
					   TableModelEvent.ALL_COLUMNS, TableModelEvent.INSERT ) ) ;
  }
  public String getUsernameAt( int row ) { return (String)user.elementAt(row); }
  public int getRowCount()               { return ( filename.size() ); }
  public Class getColumnClass( int c )   { return ( getValueAt( 0, c ).getClass() ); }
  
  public boolean isCellEditable( int row, int column )
  {
    return( false ) ;
  }
  
  public String getColumnName( int columnIndex )
  {
    int count = 0 ;
    int i ;
    for( i=0; i<columns.length; i++ )
      {
        if( columnsOnOff[i] == true )
          count++ ;
        if( count == (columnIndex+1) )
          break ;
      }
    return( columns[i] ) ;
  } 
}

